%DEMO_LG Demonstrates the usage of pdNCG solver for logistic regression
%problems:
%
% min tau*||x||_1 + phi(X,labels),
%
% X is the matrix which stores the training samples and y are the labels.
% The problem must be strongly convex.

% Copyright (c) 2014. Kimon Fountoulakis and Jacek Gondzio.

clear;

% Load a problem (X,labels). This problem corresponds to the data for the
% heart_scale problem in 
% http://www.csie.ntu.edu.tw/~cjlin/libsvmtools/datasets/binary.html#heart
load data_lg.mat

[~, n] = size(X);

% Options.
opts.problem = 'lg';
opts.n = n;
opts.tau  = 1;

opts.X = X;
opts.y = labels;
       
% Call pdNCG.
[x, y, out] = pdNCGinterface(opts);

fprintf('CPU time: %d \n', out.cput);

clear;
