%DEMO_LS Demonstrates the usage of pdNCG solver for least squares problems:
%
%  min tau*||x||_1 + 0.5||Ax-b||_2^2.

% Copyright (c) 2014. Kimon Fountoulakis and Jacek Gondzio.

clear;

% Load a problem (A,b,xopt,fvalOpt), where its optimal solution xopt can be
% calculated for tau = 1.0.
load data_ls.mat

[~, n] = size(A);

% Options.
opts.problem = 'ls';
opts.n = n;
opts.tau  = 1.0;

opts.A = A;
opts.b = b;

% Call pdNCG.
[x, y, out] = pdNCGinterface(opts);

fprintf('CPU time: %d \n', out.cput);

fprintf('Rellative error: %d \n', norm(x-xopt)/norm(xopt));

clear;