function opts = checkOptions_ls_lg_user_wavelet_tv(opts)
%CHECKOPTION Checks common input arguments for 'ls', 'lg', 'user', 
%'wavelet and 'tv' for pdNCG.
%
% Copyright (c) 2014.Ioannis Dassios, Kimon Fountoulakis and Jacek Gondzio.

if strcmp(opts.problem,'ls')
    opts = checkOptions_ls(opts);
end    
if strcmp(opts.problem,'lg') 
    opts = checkOptions_lg(opts);
end
if strcmp(opts.problem,'wavelet') 
    opts = checkOptions_W(opts);
end
if strcmp(opts.problem,'tv')    
    opts = checkOptions_tv(opts);
end
if strcmp(opts.problem,'user')
    opts = checkOptions_user(opts);
end

if isfield(opts, {'user_stop'}) 
    if strcmpi(class(opts.user_stop), 'function_handle')
        numInputs  = nargin(opts.user_stop);
        if numInputs ~= 7
            error('The optional function user_stop must have 7 input arguments.'); 
        end
        out_user_stop = opts.user_stop(randn(opts.n,1),randn(opts.n,1));
        if ~islogical(out_user_stop)
            error('The optional function user_stop must have 1 logical output.'); 
        end
    else
        error('The optional function user_stop must be of type function_handle.'); 
    end
end

if isfield(opts, {'user_fcn'}) 
    if strcmpi(class(opts.user_fcn), 'function_handle')
        numInputs  = nargin(opts.user_fcn);
        numOutputs = nargout(opts.user_fcn);
        if numInputs ~= 8 || numOutputs ~= -1
            error('The optional function user_fcn must have 8 input arguments and no output.'); 
        end
    else
        error('The optional function user_fcn must be of type function_handle.'); 
    end
end

if ~isfield(opts, {'prec_itrs'})  
    opts.prec_itrs = 15;
else
    if opts.prec_itrs <= 0
        error('opts.prec_itrs must be positive.'); 
    end
end