function [x_new, a] = simple_bt(x, nwtn, f_phi, f_huber, normN_scaled, opts)
%SIMPLE_BT Simple backtracking algorithm for problem of pdNCG.
%
% Copyright (c) 2014.  Kimon Fountoulakis and Jacek Gondzio.

a = 1.0;
a = a*opts.maxstepsize;  

f_phi_x   = f_phi(x);
f_huber_x = f_huber(x);
f_x       = f_phi_x + f_huber_x;

for j=1:opts.max_itr_bt    
    x_new = x + a.*nwtn;
    if (f_huber(x_new) + f_phi(x_new) <= f_x - opts.c2*a*normN_scaled)
        break;
    end   
    a = a*opts.c3;
end